﻿/* TODO ERROR: Skipped RegionDirectiveTrivia */// 
// Copyright (c) Microncode.com
// 
// This source is subject to the Microsoft Public License. 
// See https://opensource.org/licenses/ms-pl.html.
// All other rights reserved. 
// 
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
// EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED 
// WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE. 
// 
/* TODO ERROR: Skipped EndRegionDirectiveTrivia */
using System;
using System.Diagnostics;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;
using CSScreenRecorder;
using Microsoft.VisualBasic;
using Microsoft.VisualBasic.CompilerServices;

namespace CSScreenRecorderExampleVB
{

    /// <summary>
/// The main example of using the CSScreenRecorder library.
/// </summary>
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        // Create a new instance of the library
        private ScreenRecorder ScreenRecorder;

        private void frmMain_Load(object sender, EventArgs e)
        {
            // Add rotate style
            this.cboRotate.Items.Add("RotateNoneFlipNone");
            this.cboRotate.Items.Add("RotateNoneFlipXY");
            this.cboRotate.Items.Add("RotateNoneFlipY");

            // Set the rotate to none
            this.cboRotate.SelectedIndex = 0;


            // Set the spinning tool style
            foreach (PropertyInfo prop in typeof(Color).GetProperties())
            {
                if (Equals(prop.PropertyType.FullName, "System.Drawing.Color"))
                    this.cboSpinningToolColor.Items.Add(prop.Name);
            }

            this.cboSpinningToolColor.Text = "Red";
            this.cboSpinningToolStyle.Text = "Dot";
            using (var ScreenRecorder = new ScreenRecorder("UserName", "RegKey"))
            {

                // Get the available codecs
                foreach (ScreenRecorder.Codecs Codec in ScreenRecorder.GetCodecs())
                {
                    Console.WriteLine(Codec.CodecName);
                    this.cboVideoCodecs.Items.Add(Codec.CodecName);
                }

                this.cboVideoCodecs.SelectedIndex = 1;

                /* TODO ERROR: Skipped RegionDirectiveTrivia */
                // Formats:
                this.cboAudioFormat.DataSource = ScreenRecorder.GetAudioFormats();
                this.cboAudioFormat.Text = "MP3";

                // Bitrate
                this.cboBitrate.DataSource = ScreenRecorder.GetAudioBitrates();
                this.cboBitrate.Text = "192";

                // Samplerate
                this.cboSamplerate.DataSource = ScreenRecorder.GetAudioSamplerates();
                this.cboSamplerate.Text = "44100";

                // Bit depth
                this.cboBits.DataSource = ScreenRecorder.GetAudioBits();
                this.cboBits.Text = "16";

                // Channels
                this.cboChannels.DataSource = ScreenRecorder.GetAudioChannels();
                this.cboChannels.Text = "2";

                // Recorder mode
                this.cboRecorderMode.DataSource = ScreenRecorder.GetAudioModes();
                this.cboRecorderMode.SelectedItem = ScreenRecorder.GetEnumValue(ScreenRecorder.AudioMode);

                /* TODO ERROR: Skipped EndRegionDirectiveTrivia */
            }

            // Set the area to record to a full screen
            this.txtTop.Text = "0";
            this.txtLeft.Text = "0";

            // Full screen width and height
            this.txtWidth.Text = Screen.PrimaryScreen.Bounds.Width.ToString();
            this.txtHeight.Text = Screen.PrimaryScreen.Bounds.Height.ToString();
        }

        private void btnSpinningTool_Click(object sender, EventArgs e)
        {
            var SpinningSelection = new SpinningSelection();


            // In order to get your own UserName and RegKey please order a license.
            using (var ScreenRecorder = new ScreenRecorder("UserName", "RegKey"))
            {
                // Set the spinning tool border color
                ScreenRecorder.SpinningToolColor = Color.FromName(this.cboSpinningToolColor.SelectedItem.ToString());

                // Set the spinning tool border size
                ScreenRecorder.SpinningToolBorderSize = int.Parse(this.txtSpinningToolBorder.Text);

                // Set the spinning tool border style
                ScreenRecorder.SpinningToolStyle = (System.Drawing.Drawing2D.DashStyle)Conversions.ToInteger(this.cboSpinningToolStyle.SelectedIndex);

                // On Spinning Selection
                // Spinning tool selection event:
                ScreenRecorder.OnSpinningSelection += (o, Cancel, Top, Left, Width, Height) => { if (Cancel) { this.txtLog.Text = this.txtLog.Text + DateTime.Now + ":Spinner tool canceled" + Constants.vbCrLf; } else { this.txtTop.Text = Top.ToString(); this.txtLeft.Text = Left.ToString(); this.txtWidth.Text = Width.ToString(); this.txtHeight.Text = Height.ToString(); this.txtLog.Text = this.txtLog.Text + DateTime.Now + ":Spinner tool selected - " + Top + " " + Left + " " + Width + " " + Height + Constants.vbCrLf; } };


                // Display the spinning tool
                SpinningSelection = ScreenRecorder.SpinningTool();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // Get active window
            var activewindow = new ActiveWindow();
            activewindow = ScreenRecorder.GetActiveWindow();

            // Set the active window coordinates
            this.txtTop.Text = activewindow.Top.ToString();
            this.txtLeft.Text = activewindow.Left.ToString();
            this.txtWidth.Text = activewindow.Width.ToString();
            this.txtHeight.Text = activewindow.Height.ToString();
        }

        private void btnActiveWindow_Click(object sender, EventArgs e)
        {
            if (!this.timer1.Enabled)
            {
                // Start get active window
                this.timer1.Enabled = true;
                this.btnActiveWindow.Text = "Stop";
            }
            else
            {
                // Stop get active window
                this.timer1.Enabled = false;
                this.btnActiveWindow.Text = "Get active window";
            }
        }

        [Obsolete]
        private void cmdRecord_Click(object sender, EventArgs e)
        {

            // Using ScreenRecorder = New ScreenRecorder("UserName", "RegKey")
            using (CSharpImpl.__Assign(ref ScreenRecorder, new ScreenRecorder("UserName", "RegKey")))
            {
                /* TODO ERROR: Skipped RegionDirectiveTrivia */
                // Set the area to record
                ScreenRecorder.RecordScreenHeight = int.Parse(this.txtHeight.Text);
                ScreenRecorder.RecordScreenWidth = int.Parse(this.txtWidth.Text);
                ScreenRecorder.RecordScreenTop = int.Parse(this.txtTop.Text);
                ScreenRecorder.RecordScreenLeft = int.Parse(this.txtLeft.Text);

                /* TODO ERROR: Skipped EndRegionDirectiveTrivia */
                /* TODO ERROR: Skipped RegionDirectiveTrivia */
                // Set the frames rate
                ScreenRecorder.VideoFPS = 10;
                ScreenRecorder.VideoEncoderQuality = this.trcVideoEncoderQuality.Value;
                this.picPreview.SizeMode = PictureBoxSizeMode.StretchImage;

                // Set the video codec
                ScreenRecorder.VideoCodecIndex = this.cboVideoCodecs.SelectedIndex;

                /* TODO ERROR: Skipped EndRegionDirectiveTrivia */
                /* TODO ERROR: Skipped RegionDirectiveTrivia */
                // Record audio?
                ScreenRecorder.AudioRecorder = this.chkRecordAudio.Checked;

                // Set the audio device index to record from:
                ScreenRecorder.AudioDeviceIndex = this.cboAudioSource.SelectedIndex;

                // [Optional: Default is WasapiLoopbackCapture]
                // The mode of the recording process. This can be WasapiLoopbackCapture(default), WasapiCapture or LineIn:
                ScreenRecorder.AudioMode = (CSAudioRecorder.Mode)Enum.Parse(typeof(CSAudioRecorder.Mode), this.cboRecorderMode.Text);

                // [Optional: Default is 44100]
                // Set the audio sample rate to record from the device and the destination file:
                ScreenRecorder.AudioSamplerate = (CSAudioRecorder.Samplerate)Enum.Parse(typeof(CSAudioRecorder.Samplerate), this.cboSamplerate.Text);
                // Or set by value
                // audioRecorder1.SamplerateVal = 48000;

                // [Optional: Default is 16]
                // Set the bit-depth to record from the device and the destination file:
                ScreenRecorder.AudioBits = (CSAudioRecorder.Bits)Enum.Parse(typeof(CSAudioRecorder.Bits), this.cboBits.Text);

                // [Optional: Default is 2]
                // Set the number of the channels to record from the device and the destination file:
                ScreenRecorder.AudioChannels = (CSAudioRecorder.Channels)Enum.Parse(typeof(CSAudioRecorder.Channels), this.cboChannels.Text);

                // [Optional: Default is MP3]
                // The audio format of the destination file, this can be MP3 or WAV(PCM).
                ScreenRecorder.AudioFormat = (CSAudioRecorder.Format)Enum.Parse(typeof(CSAudioRecorder.Format), this.cboAudioFormat.Text);

                // [Optional: Default is 192]
                // Set the bitrate of the MP3 encoder:
                ScreenRecorder.AudioBitrate = (CSAudioRecorder.Bitrate)Enum.Parse(typeof(CSAudioRecorder.Bitrate), this.cboBitrate.Text);
                // Or set by value
                // audioRecorder1.BitrateVal = 192;
                /* TODO ERROR: Skipped EndRegionDirectiveTrivia */
                /* TODO ERROR: Skipped RegionDirectiveTrivia */
                // Track mouse move
                ScreenRecorder.TrackMouse = this.chkTrackMouse.Checked;

                // Set the rotate style
                ScreenRecorder.Rotate = RotateStyle.RotateNoneFlipNone;
                if (object.Equals(this.cboRotate.Text, "RotateNoneFlipXY"))
                    ScreenRecorder.Rotate = RotateStyle.RotateNoneFlipXY;
                if (object.Equals(this.cboRotate.Text, "RotateNoneFlipY"))
                    ScreenRecorder.Rotate = RotateStyle.RotateNoneFlipY;

                // Set the Watermark
                ScreenRecorder.WatermarkFont = new Font(new Font("Arial", 32), FontStyle.Underline);
                ScreenRecorder.WatermarkText = this.txtWatermarkText.Text;

                /* TODO ERROR: Skipped EndRegionDirectiveTrivia */
                /* TODO ERROR: Skipped RegionDirectiveTrivia */
                // On start event
                ScreenRecorder.OnStartRecord += o =>
                    {
                        this.lblPreview.Visible = false;
                        this.txtLog.Text = this.txtLog.Text + DateTime.Now + ":Start record" + Constants.vbCrLf;
                    };


                // On pause record
                ScreenRecorder.OnPauseRecord += o => this.txtLog.Text = this.txtLog.Text + DateTime.Now + ":Pause record" + Constants.vbCrLf;

                // On unpause record
                ScreenRecorder.OnUnPauseRecord += o => this.txtLog.Text = this.txtLog.Text + DateTime.Now + ":Unpause record" + Constants.vbCrLf;

                // On stop  record
                ScreenRecorder.OnStopRecord += o =>
                    {
                        this.lblPreview.Visible = true;
                        this.txtLog.Text = this.txtLog.Text + DateTime.Now + ":Stop record" + Constants.vbCrLf;
                    };


                // On preview (get the bmp image)
                ScreenRecorder.OnPreview += (o, bmp) =>
                    {
                    // Preview
                    var pImage = new Bitmap(bmp);
                        this.picPreview.Image = pImage;
                    };
                ScreenRecorder.OnError += (o, ErrorMessage, ErrorNumber) => this.txtLog.Text = this.txtLog.Text + DateTime.Now + ":Error - " + ErrorMessage + " (" + ErrorNumber + ")" + Constants.vbCrLf;

                /* TODO ERROR: Skipped EndRegionDirectiveTrivia */
                // Set the file name
                this.txtFileName.Text = Application.StartupPath + @"\" + DateTime.Now.ToString("yyyy-MM-dd-HH-mm-ss") + ".avi";
                ScreenRecorder.FileName = this.txtFileName.Text;

                // Start to record
                ScreenRecorder.Record();
            }
        }

        private void cmdStopRec_Click(object sender, EventArgs e)
        {
            // Stop record
            ScreenRecorder.Stop();
        }

        private void cmdPauseIn_Click(object sender, EventArgs e)
        {
            // Pause record
            ScreenRecorder.Pause();
        }

        private void cmdUnPauseIn_Click(object sender, EventArgs e)
        {
            // UnPause record
            ScreenRecorder.UnPause();
        }

        /// <summary>
    /// Order a license.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
        private void cmdOrderLicense_Click(object sender, EventArgs e)
        {
            // In order to get your own UserName and RegKey and to distribute this library
            // with your own projects for commercial or any other purpose, please order a license at:
            // https://www.microncode.com/developers/cs-screen-recorder/?cmd=order

            Process.Start("https://www.microncode.com/developers/cs-screen-recorder/?cmd=order");
        }

        private class CSharpImpl
        {
            [Obsolete("Please refactor calling code to use normal Visual Basic assignment")]
            public static T __Assign<T>(ref T target, T value)
            {
                target = value;
                return value;
            }
        }

        private void cboRecorderMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            using (var ScreenRecorder = new ScreenRecorder("UserName", "RegKey"))
            {
                // Get the selected capture mode:
                CSAudioRecorder.Mode mode = Enum.Parse(typeof(CSAudioRecorder.Mode), this.cboRecorderMode.Text);

                // Get the audio devices:
                this.cboAudioSource.DataSource = ScreenRecorder.GetDevices(mode);

                // Try to set the default device:
                int default_device_index = ScreenRecorder.GetDeviceDefaultIndex(mode);
                if (default_device_index != -1)
                {
                    // Set the default device index:
                    this.cboAudioSource.SelectedIndex = default_device_index;
                }
                else
                {
                    // LineIn will always return -1:
                    this.cboAudioSource.SelectedIndex = 0;
                }
            }
        }
    }
}